#!/bin/bash

[ -z "$2" ] && { echo "missing arguments! use ./proc.sh LOG_REFLECTOR.txt LOG_INITIATOR.txt"; exit 127; }

log_reflector="$1"
log_initiator="$2"

# process initiator logs for scanning failures
seq_prev=0
seq_curr=0
initiator_failure_scan=0
while read -r line
do
	seq_prev=$seq_curr
	seq_curr=$(echo "$line" | awk -F 'seq=|, ret=' '{print $2}' | sed 's/^0*//' | tr -d '\r')
	[ $((seq_curr - $seq_prev - 1)) -gt 0 ] && let initiator_failure_scan+=$((seq_curr - $seq_prev - 1))
done < <(cat $log_initiator | grep 'dm_request_add' | sort | uniq)

# process initiator logs for ranging failures
echo
echo "initiator_failure_scan: $initiator_failure_scan"
echo "initiator_failure_range: $(( $(cat $log_initiator | grep dm_request_add | uniq | wc -l ) - $(cat $log_initiator | grep -c data_ready) ))"
echo "initiator_failure_crc: $(cat $log_initiator | grep -c crc)"
echo "initiator_success: $(cat $log_initiator | grep -c qual=ok)"
echo "initiator_requests: $(cat $log_initiator | grep dm_request_add | uniq | wc -l)"

# process initiator logs for scanning failures
echo
echo "reflector_failure_scan: $((  $(cat $log_reflector | grep -c advertising) - $(cat $log_reflector | grep -c dm_request_add) ))"
echo "reflector_failure_range: $(( $(cat $log_reflector | grep dm_request_add | uniq | wc -l ) - $(cat $log_reflector | grep -c data_ready) ))"
echo "reflector_failure_crc: $(cat $log_reflector | grep -c crc)"
echo "reflector_success: $(cat $log_reflector | grep -c qual=ok)"
echo "reflector_requests: $(cat $log_reflector | grep dm_request_add | uniq | wc -l)"
echo